#include <stdio.h>
#include <math.h>
#define n1 4096
#define n2 4032
#define m  257
#define mm 720-m*m%720
int fill[mm];
double a8[8],b8[8],x3,y3,pi,cx,cy,rc,dc,alpha,delta;
double alpha1,delta1,alpha2,delta2,u1,v1,u2,v2; //  x3,y3(center)   x3+1,y3  
char   c1[14],c2[14];                           //  alpha,delta    alpha1,delta1
                                                //                  u1,v1
FILE *fp,*fp1,*fp2;                             //  x3,y3+1
char f1[30],f2[30],f3[60],ff[30],a[300];        //  alpha2,delta2
int ix,iy,ix1,iy1,icat;                         //   u2,v2
char head[72][80],h[72][80],b[80];
float x,y,bmag,sky,d[m*m],e[12288];
int n8640,n8200;
int idate,ccdno,p1,p2,q1,q2;
int q1d[2][4],q2u[2][4],q3l[2][4],q4r[2][4];
int  dat1[46]={ 101002, 101003, 101004, 101103, 101104, 101105,
                101106, 101107, 101108, 101204, 101205, 101206,
                101207, 101208, 101209, 110918, 110919, 110920,
                110921, 110922, 110923, 110924, 111024, 111025,
                111026, 111027, 111028, 111029, 111030, 111031,
                111123, 111124, 111126, 111127, 111128, 111129,
                111130, 111201, 111224, 111226, 111227, 111228,
                111229, 111230, 111231, 120101 };
int  dat2[46]={   5471,   5472,   5473,   5503,   5504,   5505,
                  5506,   5507,   5508,   5534,   5535,   5536,
                  5537,   5538,   5539,   5822,   5823,   5824,
                  5825,   5826,   5827,   5828,   5859,   5860,
                  5861,   5862,   5863,   5864,   5865,   5866,
                  5888,   5889,   5891,   5892,   5893,   5894,
                  5895,   5896,   5919,   5921,   5922,   5923,
                  5924,   5925,   5926,   5927  };
int slim9=1;                          //20120609 for slim9.c
main(int ac, char **av)               //use a*.fit, no display only
{
  int i,j,k,ip,jp,l,star,ifile='0',i11;
  
  pi=4.*atan(1.0); cx=pi/12.; cy=pi/180.;
  for(i=0;i<mm;i++)fill[i]=0;
  if(ac<3){ printf("\n\t ****** display  mosaic star *******\n");
            printf("\n\t\t                       jiang,2012,6,9\n");
            printf("\n\tNOTICE:  for 2012 version ONLY !!! \n");
            printf("\n\tUsage: mz_9 z9file starnum [!]");
            printf("\n\t       mz_9 z9file x y\n");
            printf("\n\tEx:    mz_9 a0900 2588");
            printf("\n\t\t\t           --> a0900_2588_?.fit\n");
            printf("\n\tEx:    mz_9 aa.fit 5339.6 1629.6");
            printf("\n\t\t\t           --> aa_star_?.fit");
            printf("\n\tYou can use command:");
            printf("\n\t\t\t     ds9 -zscale a0900_2588*.fit");
            printf("\n\t\t\tor   ds9 -zscale aa_star*.fit\n\n");
            exit(0);
         }
  fp=fopen("ubandlines.dat","r");
  if(fp==0)fp=fopen("/vega2/rhbin/ubandlines.dat","r");
  if(fp==0){ printf("ubandlines.dat not found!\n"); exit(0); }
  for(i=0;i<4;i++){
l00: fgets(b,80,fp); if(b[0]=='#')goto l00;
     sscanf(b,"%d %d %d %d",&q1d[0][i],&q2u[0][i],&q3l[0][i],&q4r[0][i]);}
  for(i=0;i<4;i++){
l01: fgets(b,80,fp); if(b[0]=='#')goto l01;
     sscanf(b,"%d %d %d %d",&q1d[1][i],&q2u[1][i],&q3l[1][i],&q4r[1][i]);}
  fclose(fp);

  sprintf(f1,"/DATA/done/%s.fit",av[1]); fp1=fopen(f1,"rb");
  if(fp1==0 && ac==3){ printf("%s not found!\n",f1); exit(0); }
  if(ac>3 && av[3][0]=='!')slim9=0;
  if(ac>3 && slim9){ fp1=fopen(av[1],"rb"); 
            if(fp1==0){ printf("%s not found!\n",av[1]); exit(0); }
            sscanf(av[2],"%f",&x); sscanf(av[3],"%f",&y);
            strcpy(f1,av[1]);
            for(i=0;i<20;i++)if(f1[i]=='.')break; f1[i]=0;
            sprintf(ff,"%s_star_?.fit",f1); }
  else {
    sscanf(av[2],"%d",&star);
    sprintf(f2,"%s.cat",av[1]); fp2=fopen(f2,"r");
    if(fp2==0){ sprintf(f2,"/DATA/done/%s.cat",av[1]); fp2=fopen(f2,"r"); }
    if(fp2==0){ printf("%s not found!\n",f2); exit(0); }
    fgets(a,300,fp2); fgets(a,300,fp2);
l10:
    fgets(a,300,fp2); 
    if(feof(fp2)){  fclose(fp2);
      printf("I cannot find No. %d object in %s file\n",star,f2); exit(0);
    }
    if(a[0]=='#')goto l10;
    sscanf(a,"%d",&j);
    if(j!=star)goto l10; 
    fclose(fp2);
    sscanf(&a[31],"%f %f",&x,&y);
    sscanf(&a[98],"%f",&bmag);                  // ber mag
    sprintf(ff,"%s_%d_?.fit",av[1],star);
  }
  for(i11=7;i11<14;i11++)if(ff[i11]=='?')break;
  ix=x+0.5; ix1=ix-m/2;
  iy=y+0.5; iy1=iy-m/2;
  if(slim9)printf("z_9: %7.2f %7.2f --> ",x,y);
// *.fit
  fread(head,72,80,fp1);
  sscanf(&head[3][23],"%d",&n8640);
  sscanf(&head[4][23],"%d",&n8200);
  k=indexpos(head,"SKYADU  ",72);
  sscanf(&head[k][12],"%f",&sky);
  swap4(&sky,4);

  jp=iy1*n8640+ix1+72*20;  l=k=0;
  if(iy1<0){ jp=ix1+72*20;  l=-iy1;
             for(i=0;i<l;i++)for(j=0;j<m;j++)d[k++]=sky; 
           }
  fseek(fp1,jp*4,0);
  for(i=l;i<m;i++){
    if(feof(fp1))for(j=0;j<n8640;j++)e[j]=sky;
    else fread(e,4,n8640,fp1);
    for(j=0;j<m;j++)d[k++]=e[j];
  }
  fclose(fp1);
  fillsky(d,sky,ix1,n8640-(ix1+m));
   

  k=indexpos(head,"A81     ",72);
  for(j=0;j<8;j++)sscanf(&head[k+j][10],"%lf",&a8[j]); xytoad(a8,b8);
  rc=a8[6]; dc=a8[7]; x3=x; y3=y;
  xy_rad(rc,dc,x3,y3,&alpha,&delta,1,0);
    xy_rad(rc,dc,x3+1.,y3,&alpha1,&delta1,1,0);
    xy_rad(rc,dc,x3,y3+1.,&alpha2,&delta2,1,0);
  toms2(alpha,c1,1); toms2(delta,c2,0);

  sprintf(&head[3][26],"%4d",m); 
  sprintf(&head[4][26],"%4d",m); 
  if(ac>3)sprintf(head[17],"OBJECT  = '%s %s%7.1f%7.1f '",c1,c2,x,y);
  else    sprintf(head[17],"OBJECT  = '%s %s%7.1f%7.1f%6.2fb '",c1,c2,x,y,bmag);
  k=m-x*2.-0.5; x=k*0.5;
  k=m-y*2.-0.5; y=k*0.5;
  k=indexpos(head,"CRPIX1  ",72);
  sprintf(&head[k][11]," %18.3f",(n8640+1)*.5+x);
  sprintf(&head[k+1][11]," %18.3f",(n8200+1)*.5+y);
  sprintf(head[k+2],"LTM1_1  =                  1.0 /");
  sprintf(head[k+3],"LTM2_2  =                  1.0 /");
  sprintf(head[k+4],"LTV1    =   %18.3f /",x);
  sprintf(head[k+5],"LTV2    =   %18.3f /",y);
  for(j=0;j<72;j++)for(i=0;i<80;i++)if(head[j][i]==0)head[j][i]=32;
  ff[i11]=ifile; fp=fopen(ff,"wb");
  fwrite(head,72,80,fp);
  fwrite(d,m*m,4,fp);
  fwrite(fill,mm,4,fp);
  if(slim9)printf("%s %s --> %s\n",c1,c2,ff);
  fclose(fp); ifile++;

  sscanf(&head[0][45],"%d",&icat);
//  printf("%d\n",icat);
  for(ip=0;ip<icat;ip++){
    i=ip/4+1;
    j=(ip%4)*12+32;
    sscanf(&head[i][j],"%d",&k);
    for(l=0;l<46;l++)if(k==dat2[l])break; head[i][j+11]=0;
    sprintf(f3,"/CAT/%d/p%s.fit",dat1[l],&head[i][j]); 
    fp2=fopen(f3,"rb");
    if(!fp2){
      sprintf(f3,"/uba/%d/p%s.fit",dat1[l],&head[i][j]); 
      fp2=fopen(f3,"rb");
      if(!fp2){ printf("/CAT & %s not found!\n",f3); continue; }
    }
    idate=0; if(k>5700)idate=1; ccdno=head[i][j+10]-48;
//        printf("idate ccdno: %d %d\n",idate,ccdno);
    fread(h,72,80,fp2);  
    k=indexpos(h,"A81     ",72);
    for(j=0;j<8;j++)sscanf(&h[k+j][10],"%lf",&a8[j]); xytoad(a8,b8);
    k=indexpos(h,"SKYADU  ",72);
    sscanf(&h[k][12],"%f",&sky);
    swap4(&sky,4);
    rc=a8[6]; dc=a8[7]; 
    rad_xy(rc,dc,alpha,delta,&x3,&y3,2,0);
      rad_xy(rc,dc,alpha1,delta1,&u1,&v1,2,0);
      rad_xy(rc,dc,alpha2,delta2,&u2,&v2,2,0);
    
    i=ccdno-1;
    p1=q3l[idate][i]; p2=4095-q4r[idate][i];
    q1=q1d[idate][i]; q2=4031-q2u[idate][i];

    if(x3<=p1 || x3>=p2 )goto n100;
    if(y3<=q1 || y3>=q2 )goto n100;
    if(idate==0 && ccdno==4)if(x3<=2048 || y3>=2015)goto n100;

//    if(x3>p1 && x3<p2 && y3>q1 && y3<q2){
      ix1=x3-m/2; iy1=y3-m/2;                
      jp=iy1*n1+ix1+72*20;  l=k=0;
      if(iy1<0){ jp=ix1+72*20;  l=-iy1; 
             for(i=0;i<l;i++)for(j=0;j<m;j++)d[k++]=sky; 
           }
      fseek(fp2,jp*4,0);
      for(i=l;i<m;i++){
        if(feof(fp2))for(j=0;j<n1;j++)e[j]=sky;
        else fread(e,4,n1,fp2);
        for(j=0;j<m;j++)d[k++]=e[j];
      }
      fillsky(d,sky,ix1,n1-(ix1+m));
      if(slim9)printf("%s  -->  %7.2lf %7.2lf",f3,x3,y3);
      sprintf(&h[3][26],"%4d",m);
      sprintf(&h[4][26],"%4d",m);
      sprintf(&h[17][17]," %s%7.1lf%7.1lf '",&f3[5],x3,y3);
      k=indexpos(h,"CROTA2  ",72);
      for(j=0;j<11;j++)for(i=0;i<31;i++)h[j+k][i]=head[j+k][i];
      j=m-x3*2.-0.5; x=j*0.5;
      j=m-y3*2.-0.5; y=j*0.5;
      sprintf(h[k+9],"LTV1    =   %18.3f /",x);
      sprintf(h[k+10],"LTV2    =   %18.3f /",y);
      for(j=-2;j<7;j++)for(i=0;i<31;i++)h[j+k][i]=32;  // clesr
      
      for(j=0;j<72;j++)for(i=0;i<80;i++)if(h[j][i]==0)h[j][i]=32;
      ff[i11]=ifile; fp=fopen(ff,"wb");
      fwrite(h,72,80,fp);
      fwrite(d,m*m,4,fp);
      fwrite(fill,mm,4,fp);
      fclose(fp); ifile++;
      if(slim9)printf("  ---> %s\n",ff);
      if(slim9)printf("\t\t\t center resize, dx: %7.4lf  dy:  %7.4lf\n",u1-x3,v2-y3);
n100:
//    }  
    fclose(fp2);
  }
  ff[i11]='?';
  if(slim9)printf("\n==> Next:  may use command: ds9 -zscale %s\n\n",ff);
}

fillsky(d,sky,ix1,ix2)
float d[m][m],sky; int ix1,ix2;
{
  int i,j,k;
  if(ix1<0){
    k=-ix1;
    for(j=0;j<m;j++)for(i=0;i<k;i++)d[j][i]=sky;
    return;
  }
  if(ix2<0){
    k=m+ix2;
    for(j=0;j<m;j++)for(i=k;i<m;i++)d[j][i]=sky;
  }
}  

xytoad(x,a)
double *x,*a;
{
  double z;
  z=x[0]*x[3]-x[2]*x[1];
  a[0]= x[3]/z;
  a[1]=-x[1]/z;
  a[2]=-x[2]/z;
  a[3]= x[0]/z;
  a[4]= (x[2]*x[5]-x[4]*x[3])/z;
  a[5]= (x[4]*x[1]-x[0]*x[5])/z;
}

#define bok  48.
rad_xy(ac,dc,ra,de,x,y,type,k)
double ac,dc,ra,de,*x,*y;  int type,k;
{
  double xi,xn, tmp,rar,der;
  rar=ra*cx; der=de*cy;
  tmp=atan(tan(der)/cos(rar-ac));
  xi=cos(tmp)*tan(rar-ac)/cos(tmp-dc);
  xn=tan(tmp-dc);
  if(type==1){     // schmidt TELESCOPE
    tmp=sqrt(xi*xi+xn*xn);
    if(tmp!=0.){
      tmp=atan(tmp)/tmp;
      xi*=tmp; xn*=tmp;
    }
  }
  if(type==2){    //  BOK telescope
    tmp=1.+bok*(xi*xi+xn*xn);
    xi*=tmp; xn*=tmp;
  }
  if(k==0){
    *x=b8[0]*xi+b8[2]*xn+b8[4];
    *y=b8[1]*xi+b8[3]*xn+b8[5];
  }
  if(k==1){ *x=xi; *y=xn;}
}

xy_rad(ac,dc,x,y,ra,de,type,k)
double ac,dc,x,y,*ra,*de;  int type,k;
{
  double xi,xn,tmp,tmp1;
  double x1,y1,r1,d1;
  int i;
  xi=a8[0]*x+a8[2]*y+a8[4];
  xn=a8[1]*x+a8[3]*y+a8[5];
  if(type==1){
    tmp=sqrt(xi*xi+xn*xn);
    if(tmp!=0.){
      tmp=tan(tmp)/tmp;
      xi*=tmp;  xn*=tmp;
    }
  }
  if(type==2){
    tmp=1.+bok*(xi*xi+xn*xn);
    for(i=0;i<4;i++){
      x1=xi/tmp; y1=xn/tmp;
      tmp=tan(dc);  tmp1=1.-y1*tmp;
      r1=atan(x1/cos(dc)/tmp1);
      d1=atan((y1+tmp)*cos(r1)/tmp1);
      r1+=ac;
      tmp=atan(tan(d1)/cos(r1-ac));
      x1=cos(tmp)*tan(r1-ac)/cos(tmp-dc);
      y1=tan(tmp-dc);
      tmp=1.+bok*(x1*x1+y1*y1);
//                                 printf("%lf\n",tmp);
    }
    xi/=tmp; xn/=tmp;
  }
  tmp=tan(dc);  tmp1=1.-xn*tmp;
  *ra=atan(xi/cos(dc)/tmp1);
  *de=atan((xn+tmp)*cos(*ra)/tmp1);
  *ra+=ac;
  tmp=(*de)-dc; if(tmp<0.)tmp=-tmp;
  if(tmp>2.){  *de=-(*de);  *ra+=pi; }
  if(*ra<0.)*ra+=(pi+pi);
  if(k==0){ *ra/=cx; *de/=cy; }
}

toms2(aa,c,k)
double aa;           // input
char c[14];          // output
int k;               // input
{
  int  i,j;
  double a,b,x;
  a=aa;
  if(k==1){ if(a>24.)a-=24.; if(a<0.)a+=24.; }
  c[0]=32; if(a<0.){ a=-a; c[0]='-'; }
  i=a; b=(a-i)*60.;
  j=b; x=(b-j)*60.;
  if(j==60){ j=0; i++; }
  if(k==1)sprintf(&c[1],"%2.2d:%2.2d:%6.3f",i,j,x);
  if(k==0)sprintf(&c[1],"%2.2d:%2.2d:%5.2f",i,j,x);
  if(c[7]==32)c[7]='0';   if(c[8]==32)c[8]='0';
  if(c[7]=='6'){
    c[7]='0'; j++; sprintf(&c[4],"%2.2d",j);
    if(c[4]=='6'){
      c[4]='0'; i++; sprintf(&c[1],"%2.2d",i);
    }
    c[3]=':'; c[6]=':';
  }
}

chs(a,y)
char *a; double *y;
{
  double x;
  char b[20];
  int i,j,k;
  strncpy(b,a,14); k=strlen(b);
  j=1; for(i=0;i<k;i++){ if(b[i]==32)continue; if(b[i]=='-')j=-1; break; }
  for(i=0;i<k;i++)if(b[i]<'.' || b[i]> '9')b[i]=32;
  i=k=0; x=0.; sscanf(b,"%d %d %lf",&i,&k,&x);
  x=k/60.+x/3600.+i;
  *y=x*j;
}

